package com.pancik.libgdx.zumpatalentov.engine;

public class DelayedAction {
    public static interface Callback {
        public void onDelayEnded();
    }
    
    protected int delayTime;
    protected Callback callback;

    protected int delayCurrent = 0;
    protected boolean called = false;
    
    public DelayedAction(int delayTime, Callback callback) {
        this.delayTime = delayTime;
        this.callback = callback;
    }
    
    public void tick() {
        delayCurrent++;
        if(delayCurrent >= delayTime) {
            callback.onDelayEnded();
            called = true;
        }
    }
    
    public boolean remove() {
        return called;
    }
}
