package com.pancik.libgdx.zumpatalentov.engine.building;

import com.badlogic.gdx.math.Vector2;
import com.pancik.libgdx.zumpatalentov.engine.player.Player;
import com.pancik.libgdx.zumpatalentov.entity.attackable.AttackableEntity;

public abstract class TowerBuilding extends AttackableEntity {

    protected int attackCdStep = 0;
    protected boolean attacked = false;
    
    public TowerBuilding(Vector2 pos, Vector2 size, int team, Player owner) {
        super(pos, size, team, owner);
    }

    @Override
    public void tick() {
        if(attacked) {
            attackCdStep++;
            if(attackCdStep >= getAttackCooldown()) {
                attacked = false;
                attackCdStep = 0;
            }
        }
        
        
        towerTick();
    }
    
    public void tryAttack(AttackableEntity e) {
        if(!attacked) {
            if(attack(e)) {
                attacked = true;
            }
        }
    }

    public abstract void forceRemove();
    public abstract boolean hitsTexture(int posx, int posy);
    public abstract void towerTick();
    public abstract boolean attack(AttackableEntity e);
    public abstract int getAttackCooldown();
}
