package com.pancik.libgdx.zumpatalentov.engine.component;

import com.pancik.libgdx.zumpatalentov.engine.particle.Particle;
import java.util.ArrayList;
import java.util.List;

public class ParticleManager {
    private List<Particle> particles;
    
    public ParticleManager() {
        this.particles = new ArrayList<Particle>();
    }
    
    public void tick() {
        //System.out.println("Particle size: " + particles.size());
        for(int i = 0; i < particles.size(); i++) {
            if(!particles.get(i).remove()) {
                particles.get(i).tick();
            }
        }
        
        for(Particle particle : particles) {
            if(particle.remove()) {
                particles.remove(particle);
                break;
            }
        }
    }
    
    public void earlyRender() {
        for(Particle particle : particles) {
            if(!particle.remove()) {
                particle.earlyRender();
            }
        }
    }
    
    public void lateRender() {
        for(Particle particle : particles) {
            if(!particle.remove()) {
                particle.lateRender();
            }
        }
    }
    
    public void addParticle(Particle p) {
        particles.add(p);
    }
}
