package com.pancik.libgdx.zumpatalentov.engine.component;

import com.pancik.libgdx.zumpatalentov.engine.player.Player;
import java.util.Set;
import java.util.TreeSet;

public class PlayerManager {
    private Set<Player> players = new TreeSet<Player>();

    public void addPlayer(Player p) {
        players.add(p);
    }
    
    public void tick() {
        for(Player p : players) {
            p.tick();
        }
    }

    public Player getPlayerByID(Long id) {
        Player out = null;
        
        for(Player p : players) {
            if(p.getId() == id) {
                out = p;
                break;
            }
        }
        
        return out;
    }
    
    public Player getPlayerByNumber(Long number) {
        Player out = null;
        
        for(Player p : players) {
            if(p.getNumber() == number) {
                out = p;
                break;
            }
        }
        
        return out;
    }
    
    public Set<Player> getPlayersWithTeam(Long team) {
        Set<Player> out = new TreeSet<Player>();
        
        for(Player p : players) {
            if(p.getTeam() == team) {
                out.add(p);
            }
        }
        
        return out;
    }
    
    public boolean isWinner(int number) {
        boolean out = true;
        
        for(Player p : players) {
            if(p.getNumber() != number) {
                if(!p.isDefeated()) {
                    out = false;
                    break;
                }
            }
        }
        
        return out;
    }
}
