package com.pancik.libgdx.zumpatalentov.engine.tile;

import com.badlogic.gdx.graphics.Texture;
import com.pancik.libgdx.zumpatalentov.DrawableData;
import com.pancik.libgdx.zumpatalentov.util.RandomGenerator;
import com.pancik.libgdx.zumpatalentov.util.RenderUtils;

public class FloorTile extends Tile {
    public static Texture FLOOR_TILE_TEXTURE = DrawableData.textures.get("floor_tile");
    public static final int TEX_WIDTH = 128;
    public static final int TEX_HEIGHT = 128;
    
    private int imageIndex = RandomGenerator.getRandom(16);
    
    public FloorTile(int posx, int posy) {
        super(posx, posy, Type.GRASS);
    }

    @Override
    public void tick() {
    }

    @Override
    public void render() {
        RenderUtils.blit(DrawableData.spriteBatch,
                FLOOR_TILE_TEXTURE,
                new RenderUtils.ScreenInfo(posx - TILE_SIZE/2,
                    posy - TILE_SIZE/2,
                    Tile.TILE_SIZE,
                    Tile.TILE_SIZE),
                new RenderUtils.ScreenInfo(TEX_WIDTH * (imageIndex % 4), TEX_HEIGHT * (imageIndex % 4), TEX_WIDTH, TEX_HEIGHT));
    }

    @Override
    public void setTextureImageIndex(int index) {
    }

    @Override
    public void setNeighbourTile(Tile t) {
    }

    @Override
    public Texture getUnderlyingTexture() {
        return FLOOR_TILE_TEXTURE;
    }

    @Override
    public boolean isWalkable() {
        return true;
    }
}
