package com.pancik.libgdx.zumpatalentov.engine.tile;

import com.badlogic.gdx.graphics.Texture;

public abstract class Tile {
    public static final int TILE_SIZE = 64;
    
    public static enum Type {
        GRASS,
        ROAD,
        WALL,
        FLOOR;
    }
    
    protected int posx;
    protected int posy;
    protected Type type;

    public Tile(int posx, int posy, Type type) {
        this.posx = posx;
        this.posy = posy;
        this.type = type;
    }

    public int getPosx() {
        return posx;
    }

    public int getPosy() {
        return posy;
    }
    
    public abstract void tick();
    public abstract void render();
    
    public abstract boolean isWalkable();
    public abstract void setTextureImageIndex(int index);
    public abstract void setNeighbourTile(Tile t);
    public abstract Texture getUnderlyingTexture();

    public Type getType() {
        return type;
    }
}
