package com.pancik.libgdx.zumpatalentov.entity.attackable;

import com.badlogic.gdx.math.Vector2;
import com.pancik.libgdx.zumpatalentov.engine.player.Player;
import com.pancik.libgdx.zumpatalentov.entity.Entity;

public abstract class AttackableEntity extends Entity {
    protected Vector2 pos;
    protected Vector2 size;
    protected int team;
    protected Player owner;

    public AttackableEntity(Vector2 pos, Vector2 size, int team, Player owner) {
        this.pos = pos;
        this.size = size;
        this.team = team;
        this.owner = owner;
    }
    
    public Vector2 getPos() {
        return pos.cpy();
    }
    
    public void addPos(Vector2 v) {
        pos.add(v);
    }

    public Vector2 getSize() {
        return size.cpy();
    }
    
    public int getTeam() {
        return team;
    }
    
    public Player getOwner() {
        return owner;
    }
    
    public abstract void getHit(int damage, AttackableEntity from);
    public abstract boolean isDead();
    
    @Override
    public float getPriority() {
        return this.pos.y;
    }
}
