package com.pancik.libgdx.zumpatalentov.entity.projectile;

import com.badlogic.gdx.math.Vector2;
import com.pancik.libgdx.zumpatalentov.entity.Entity;

public abstract class Projectile extends Entity {
    public static interface Callback {
        public void onProjectileArrived();
    }

    protected Vector2 targetPos;
    protected float targetDiameter;
    protected Vector2 pos;
    protected float diameter;
    protected float speed;
    protected Callback callback;
    
    protected float angle;
    protected boolean hit = false;

    public Projectile(Vector2 targetPos, float targetDiameter, Vector2 pos, float diameter, float speed, Callback callback) {
        this.targetPos = targetPos;
        this.targetDiameter = targetDiameter;
        this.pos = pos;
        this.diameter = diameter;
        this.speed = speed;
        this.callback = callback;
    }

    @Override
    public void tick() {
        Vector2 dir = this.targetPos.cpy();
        dir.sub(pos);
        this.angle = dir.angle();
        if(dir.len() > speed) {
            dir.nor();
            dir.mul(speed);
            this.pos.add(dir);
        } else {
            this.pos.set(targetPos);
        }
        
        if(!remove()) {
            if(targetPos.dst(pos) < diameter/2) {
                if(!hit) {
                    callback.onProjectileArrived();
                    onProjectileArrived();
                    hit = true;
                }
            }
        }
    }
    
    @Override
    public boolean remove() {
        return hit;
    }
    
    @Override
    public float getPriority() {
        return this.pos.y;
    }
    
    protected abstract void onProjectileArrived();
}
