package com.pancik.libgdx.zumpatalentov.entity.unit.buff;

import com.pancik.libgdx.zumpatalentov.DrawableData;

public class TowerSlow implements Buff {
    private static final int BUFF_LIFETIME = 600;
    
    private int life = 0;
    
    @Override
    public void tick() {
        life++;
    }

    @Override
    public void preRender() {
        DrawableData.spriteBatch.setColor(0.6f, 0.6f, 1.0f, 1.0f);
    }

    @Override
    public void postRender() {
        DrawableData.spriteBatch.setColor(1.0f, 1.0f, 1.0f, 1.0f);
    }

    @Override
    public boolean remove() {
        return (life >= BUFF_LIFETIME);
    }

    @Override
    public float getCoefficient(PercentageStat stat) {
        switch(stat) {
            case MOVEMENT_SPEED:
                return -0.30f;
        }
        
        return 0.0f;
    }
}
