package com.pancik.libgdx.zumpatalentov.screens;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.Graphics;
import com.pancik.libgdx.zumpatalentov.DrawableData;
import com.pancik.libgdx.zumpatalentov.MainApplicationListener;
import com.pancik.libgdx.zumpatalentov.SoundData;
import com.pancik.libgdx.zumpatalentov.ui.ButtonHorizontalAlignment;
import com.pancik.libgdx.zumpatalentov.ui.ButtonImageEnum;
import com.pancik.libgdx.zumpatalentov.ui.ButtonModifier;
import com.pancik.libgdx.zumpatalentov.ui.ButtonVerticalAlignment;
import com.pancik.libgdx.zumpatalentov.ui.ClickableButton;
import com.pancik.libgdx.zumpatalentov.ui.UIHandler;
import com.pancik.libgdx.zumpatalentov.util.InputData;
import com.pancik.libgdx.zumpatalentov.util.MouseEvent;

public class PickModeScreen implements Screen {
    private UIHandler uiHandler;
    private Graphics.DisplayMode best = null;
    
    public PickModeScreen(final MainApplicationListener main) {
        SoundData.playMenuMusic();
        this.uiHandler = new UIHandler();
        
        best = Gdx.graphics.getDesktopDisplayMode();
        
        this.uiHandler.addButton(new ClickableButton(ButtonHorizontalAlignment.MIDDLE,
                -120,
                ButtonVerticalAlignment.BOTTOM,
                -118,
                "Windowed",
                ButtonImageEnum.WH_200_118,
                new ClickableButton.CallbackHandler() {
                    @Override
                    public void onButtonPressed() {
                        main.setScreen(new SelectLevelScreen(main));
                    }
                }, false));
        
        this.uiHandler.addButton(new ClickableButton(ButtonHorizontalAlignment.MIDDLE,
                +120,
                ButtonVerticalAlignment.BOTTOM,
                -118,
                "Fullscreen",
                ButtonImageEnum.WH_200_118,
                new ClickableButton.CallbackHandler() {
                    @Override
                    public void onButtonPressed() {
                        Gdx.graphics.setDisplayMode(best.width, best.height, true);
                        main.setScreen(new SelectLevelScreen(main));
                    }
                }, ButtonModifier.RECOMMENDED));
    }
    
    @Override
    public void tick() {
        for(MouseEvent me : InputData.mouseEvents) {
            uiHandler.handle(me);
        }
    }

    @Override
    public void render() {
    }

    @Override
    public void renderUI() {
        DrawableData.renderFrontScreen();
        
        uiHandler.render();
        
        /*
        RenderUtils.blitText(DrawableData.spriteBatch,
                "Fullscreen resolution found: " + best.width + "x" + best.height,
                ButtonHorizontalAlignment.MIDDLE, 0,
                ButtonVerticalAlignment.MIDDLE,  138,
                RenderUtils.TextAlligment.MIDDLE, RenderUtils.TextAlligment.BOTTOM);
        */
    }

    @Override
    public void handleBackButtonPressed() {
    }

    @Override
    public void handleMenuButtonPressed() {
    }
}
