package com.pancik.libgdx.zumpatalentov.ui;

import com.pancik.libgdx.zumpatalentov.DrawableData;

public enum ButtonImageEnum {
    WH_128_128("128x128", "128x128_down", 0, 0, 128, 128, 128, 128, 0, 0, 128, 128),
    WH_200_118("200x118", "200x118_down", 0, 0, 200, 118, 200, 118, 0, 0, 200, 118),
    WINDOW_ARROW_RIGHT_64_64("arrow_right", "arrow_right_down", 0, 0, 128, 128, 64, 64, 0, 0, 128, 128),
    WINDOW_ARROW_LEFT_64_64("arrow_left", "arrow_left_down", 0, 0, 128, 128, 64, 64, 0, 0, 128, 128),
    WINDOW_BIG_BUTTON_128_64("window_button_big", "window_button_big_down", 0, 0, 512, 256, 128, 64, 0, 0, 512, 256),
    WINDOW_RECTANGLE_BUTTON_64_64("window_button_rectangle", "window_button_rectangle_down", 0, 0, 128, 128, 64, 64, 0, 0, 128, 128),
    WINDOW_X_BUTTON_32_32("window_button_x", "window_button_x_down", 0, 0, 64, 64, 32, 32, 0, 0, 64, 64);

    private String textName;
    private String clickedTextName;
    private int textBegx;
    private int textBegy;
    private int textEndx;
    private int textEndy;
    private int sizex;
    private int sizey;
    private int clickedTextBegx;
    private int clickedTextBegy;
    private int clickedTextEndx;
    private int clickedTextEndy;

    private ButtonImageEnum(String textName, String clickedTextName, int textBegx, int textBegy, int textEndx, int textEndy, int sizex, int sizey, int clickedTextBegx, int clickedTextBegy, int clickedTextEndx, int clickedTextEndy) {
        this.textName = textName;
        this.clickedTextName = clickedTextName;
        this.textBegx = textBegx;
        this.textBegy = textBegy;
        this.textEndx = textEndx;
        this.textEndy = textEndy;
        this.sizex = sizex;
        this.sizey = sizey;
        this.clickedTextBegx = clickedTextBegx;
        this.clickedTextBegy = clickedTextBegy;
        this.clickedTextEndx = clickedTextEndx;
        this.clickedTextEndy = clickedTextEndy;
    }

    public String getTextName() {
        return textName;
    }

    public int getTextBegx() {
        return textBegx;
    }

    public int getTextBegy() {
        return textBegy;
    }

    public int getTextEndx() {
        return textEndx;
    }

    public int getTextEndy() {
        return textEndy;
    }

    public int getSizex() {
        return sizex;
    }

    public int getSizey() {
        return sizey;
    }

    public int getDensitySizex() {
        return (int)((float)sizex * DrawableData.getDensity());
    }

    public int getDensitySizey() {
        return (int)((float)sizey * DrawableData.getDensity());
    }

    public String getClickedTextName() {
        return clickedTextName;
    }

    public int getClickedTextBegx() {
        return clickedTextBegx;
    }

    public int getClickedTextBegy() {
        return clickedTextBegy;
    }

    public int getClickedTextEndx() {
        return clickedTextEndx;
    }

    public int getClickedTextEndy() {
        return clickedTextEndy;
    }
}