package com.pancik.libgdx.zumpatalentov.util;

public class MouseEvent {
    private int uix;
    private int uiy;
    private int gamex;
    private int gamey;
    private int pointer;
    private MouseEventType type;

    public MouseEvent() {
    }
    
    public MouseEvent(int basex, int basey, int x, int y, MouseEventType type, int pointer) {
        this.gamex = x;
        this.gamey = y;
        this.uix = basex;
        this.uiy = basey;
        this.type = type;
        this.pointer = pointer;
    }

    public int getGameUnprojectedX() {
        return gamex;
    }

    public int getGameUnprojectedY() {
        return gamey;
    }

    public int getUiUnprojectedX() {
        return uix;
    }

    public int getUiUnprojectedY() {
        return uiy;
    }

    public MouseEventType getType() {
        return type;
    }

    public int getPointer() {
        return pointer;
    }

    public boolean mouseUp() {
        if(type == MouseEventType.UP) {
            return true;
        } else {
            return false;
        }
    }

    public boolean mouseDown() {
        if(type == MouseEventType.DOWN) {
            return true;
        } else {
            return false;
        }
    }

    public boolean mouseDragged() {
        if(type == MouseEventType.DRAG) {
            return true;
        } else {
            return false;
        }
    }
}